import javax.swing.*;
import java.awt.*;
import java.util.Random;

public class DrawingField  extends JPanel {
    private final FormWarship Field;
    DrawingWarship _warship;
    public DrawingField(FormWarship field) {
        this.Field = field;
    }
    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        Graphics2D g2 =(Graphics2D)g;
        if (_warship!=null)
            _warship.DrawTransport(g2);
        else return;
    }
    public void UpButtonAction(){
        if (_warship!=null)
            _warship.MoveTransport(Direction.Up);
        else
            return;
    }
    public void DownButtonAction(){
        if (_warship!=null)
            _warship.MoveTransport(Direction.Down);
        else
            return;
    }
    public void RightButtonAction(){
        if (_warship!=null)
            _warship.MoveTransport(Direction.Right);
        else
            return;
    }
    public void LeftButtonAction(){
        if (_warship!=null)
            _warship.MoveTransport(Direction.Left);
        else
            return;
    }
    public void CreateButtonAction(){
        Random rand=new Random();
        _warship=new DrawingWarship();
        _warship.Init(rand.nextInt(50)+10,rand.nextInt(3000)+20000,new Color(rand.nextInt(256),rand.nextInt(256),rand.nextInt(256)));
        _warship.SetPosition(rand.nextInt(100)+10,rand.nextInt(100)+10,getWidth(),getHeight());
        Field.SpeedLabel.setText("Скорость: "+_warship.GetWarship().GetSpeed());
        Field.WeightLabel.setText("Вес: "+_warship.GetWarship().GetWeight());
        Field.BodyColorLabel.setText("Цвет: "+Integer.toHexString(_warship.GetWarship().GetBodyColor().getRGB()).substring(2));
    }
    public void ResizeField(){
        if (_warship!=null)
            _warship.ChangeBorders(getWidth(),getHeight());
        else return;
    }
}
